Text Chat. ">

Infer text

POST /ml/v1/text/generation

Infer the next tokens for a given deployed model with a set of parameters.

This API is legacy, consider using Text Chat.

Auditing

Calling this method generates the following auditing event.

  • pm-20.foundation-model.send

Request

Request Body

TextGenRequest

From a given prompt, infer the next tokens.

input

Required *

string

The prompt to generate completions. Note: The method tokenizes the input internally. It is recommended not to leave any trailing spaces.

model_id

Required *

string

The `id` of the model to be used for this request. Please refer to the list of models.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

parameters

TextGenParameters

Properties that control the model and response.

decoding_method

string

Represents the strategy used for picking the tokens during generation of the output text.

During text generation when parameter value is set to greedy, each successive token corresponds to the highest probability token given the text that has already been generated. This strategy can lead to repetitive results especially for longer output sequences. The alternative sample strategy generates text by picking subsequent tokens based on the probability distribution of possible next tokens defined by (i.e., conditioned on) the already-generated text and the top_k and top_p parameters described below. See this url for an informative article about text generation.

In future implementations, this parameter will be automatically set depending on the `temperature` parameter so this parameter will be ignored.

length_penalty

object

It can be used to exponentially increase the likelihood of the text generation terminating once a specified number of tokens have been generated.

In future implementations, this parameter will be ignored.

max_new_tokens

integer

The maximum number of new tokens to be generated. The maximum supported value for this field depends on the model being used.

How the "token" is defined depends on the tokenizer and vocabulary size, which in turn depends on the model. Often the tokens are a mix of full words and sub-words. To learn more about tokenization, see here.

Depending on the users plan, and on the model being used, there may be an enforced maximum number of new tokens.

min_new_tokens

integer

If stop sequences are given, they are ignored until minimum tokens are generated.

random_seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop_sequences

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

temperature

number

A value used to modify the next-token probabilities in sampling mode. Values less than 1.0 sharpen the probability distribution, resulting in "less random" output. Values greater than 1.0 flatten the probability distribution, resulting in "more random" output. A value of 1.0 has no effect.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the TIME_LIMIT stop reason.

Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

top_k

integer

The number of highest probability vocabulary tokens to keep for top-k-filtering. Only applies for sampling mode. When decoding_strategy is set to sample, only the top_k most likely tokens are considered as candidates for the next generated token.

top_p

number

Similar to top_k except the candidates to generate the next token are the most likely tokens with probabilities that add up to at least top_p. Also known as nucleus sampling. A value of 1.0 is equivalent to disabled.

repetition_penalty

number

Represents the penalty for penalizing tokens that have already been generated or belong to the context. The value 1.0 means that there is no penalty.

truncate_input_tokens

integer

Represents the maximum number of input tokens accepted. This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the start of the input (on the left), so the end of the input will remain the same. If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

Properties that control what is returned.

include_stop_sequence

boolean

Pass `false` to omit matched stop sequences from the end of the output text. The default is `true`, meaning that the output will end with the stop sequence text when matched.

moderations

Moderations

Properties that control the moderations, for usages such as `Hate and profanity` (HAP) and `Personal identifiable information` (PII) filtering. This list can be extended with new types of moderations.

hap

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

pii

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

granite_guardian

object

The properties specific to Granite Guardian. This detector is in beta and may change.

input_ranges

array

If set, then only these ranges will be applied to the moderations. This is useful in the case that certain parts of the input text have already been checked.

crypto

CryptoInfo

To enable encryption, configure credentials for your chosen keys management service. For details, see Encrypting inference requests.

key_ref

Required *

string

Identifier of the DEK in the chosen keys management service.

  • IBM Key Protect - full CRN (e.g. `crn:v1:bluemix:public:kms:us-south:a/12345:<instance_id>:key:<root_key_id>:wdek:<ciphertext>`) This field is required, but its exact format depends on the selected `keys_manager`. No strict pattern is enforced here - validation will be performed by the keys management service.

Response

200 - Successful operation

model_id

string

The `id` of the model for inference.

model_version

string

The model version (using semantic versioning) if set.

created_at

string

The time when the response was created in ISO 8601 format.

results

array

The generated tokens.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Text Chat Stream. ">

Infer text event stream

POST /ml/v1/text/generation_stream

Infer the next tokens for a given deployed model with a set of parameters. This operation will return the output tokens as a stream of events.

This API is legacy, consider using Text Chat Stream.

Auditing

Calling this method generates the following auditing event.

  • pm-20.foundation-model.send

Request

Request Body

TextGenStreamRequest

From a given prompt, infer the next tokens in a server-sent events (SSE) stream.

input

Required *

string

The prompt to generate completions. Note: The method tokenizes the input internally. It is recommended not to leave any trailing spaces.

model_id

Required *

string

The `id` of the model to be used for this request. Please refer to the list of models.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

parameters

TextGenParameters

Properties that control the model and response.

decoding_method

string

Represents the strategy used for picking the tokens during generation of the output text.

During text generation when parameter value is set to greedy, each successive token corresponds to the highest probability token given the text that has already been generated. This strategy can lead to repetitive results especially for longer output sequences. The alternative sample strategy generates text by picking subsequent tokens based on the probability distribution of possible next tokens defined by (i.e., conditioned on) the already-generated text and the top_k and top_p parameters described below. See this url for an informative article about text generation.

In future implementations, this parameter will be automatically set depending on the `temperature` parameter so this parameter will be ignored.

length_penalty

object

It can be used to exponentially increase the likelihood of the text generation terminating once a specified number of tokens have been generated.

In future implementations, this parameter will be ignored.

max_new_tokens

integer

The maximum number of new tokens to be generated. The maximum supported value for this field depends on the model being used.

How the "token" is defined depends on the tokenizer and vocabulary size, which in turn depends on the model. Often the tokens are a mix of full words and sub-words. To learn more about tokenization, see here.

Depending on the users plan, and on the model being used, there may be an enforced maximum number of new tokens.

min_new_tokens

integer

If stop sequences are given, they are ignored until minimum tokens are generated.

random_seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop_sequences

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

temperature

number

A value used to modify the next-token probabilities in sampling mode. Values less than 1.0 sharpen the probability distribution, resulting in "less random" output. Values greater than 1.0 flatten the probability distribution, resulting in "more random" output. A value of 1.0 has no effect.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the TIME_LIMIT stop reason.

Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

top_k

integer

The number of highest probability vocabulary tokens to keep for top-k-filtering. Only applies for sampling mode. When decoding_strategy is set to sample, only the top_k most likely tokens are considered as candidates for the next generated token.

top_p

number

Similar to top_k except the candidates to generate the next token are the most likely tokens with probabilities that add up to at least top_p. Also known as nucleus sampling. A value of 1.0 is equivalent to disabled.

repetition_penalty

number

Represents the penalty for penalizing tokens that have already been generated or belong to the context. The value 1.0 means that there is no penalty.

truncate_input_tokens

integer

Represents the maximum number of input tokens accepted. This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the start of the input (on the left), so the end of the input will remain the same. If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

Properties that control what is returned.

include_stop_sequence

boolean

Pass `false` to omit matched stop sequences from the end of the output text. The default is `true`, meaning that the output will end with the stop sequence text when matched.

moderations

Moderations

Properties that control the moderations, for usages such as `Hate and profanity` (HAP) and `Personal identifiable information` (PII) filtering. This list can be extended with new types of moderations.

hap

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

pii

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

granite_guardian

object

The properties specific to Granite Guardian. This detector is in beta and may change.

input_ranges

array

If set, then only these ranges will be applied to the moderations. This is useful in the case that certain parts of the input text have already been checked.

Response

200 - Successful operation (`Content-Type: text/event-stream`).

400 -

401 -

403 -

404 -

Text tokenization

POST /ml/v1/text/tokenization

The text tokenize operation allows you to check the conversion of provided input to tokens for a given model. It splits text into words or sub-words, which then are converted to ids through a look-up table (vocabulary). Tokenization allows the model to have a reasonable vocabulary size.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-tokenization.send

Request

Request Body

TextTokenizeRequest

The input string to tokenize.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

model_id

Required *

string

The `id` of the model to be used for this request. Please refer to the list of models.

input

Required *

string

The input string to tokenize.

parameters

TextTokenizeParameters

The parameters for text tokenization.

return_tokens

boolean

If this is `true` then the actual tokens will also be returned in the response.

crypto

CryptoInfo

To enable encryption, configure credentials for your chosen keys management service. For details, see Encrypting inference requests.

key_ref

Required *

string

Identifier of the DEK in the chosen keys management service.

  • IBM Key Protect - full CRN (e.g. `crn:v1:bluemix:public:kms:us-south:a/12345:<instance_id>:key:<root_key_id>:wdek:<ciphertext>`) This field is required, but its exact format depends on the selected `keys_manager`. No strict pattern is enforced here - validation will be performed by the keys management service.

Response

200 - Successful operation

model_id

string

The `id` of the model to be used for this request. Please refer to the list of models.

result

TextTokenizeResult

The result of tokenizing the input string.

400 -

401 -

403 -

404 -

List the available foundation models

GET /ml/v1/foundation_model_specs

Retrieve the list of deployed foundation models.

Request

Response

200 - OK

total_count

integer

The total number of resources.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

FoundationModelsArray

The supported foundation models.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

404 -

List the supported tasks

GET /ml/v1/foundation_model_tasks

Retrieve the list of tasks that are supported by the foundation models.

Request

Response

200 - OK

total_count

integer

The total number of resources.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

FoundationModelTasksArray

The supported foundation model tasks.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

404 -

Create a new watsonx.ai deployment

POST /ml/v4/deployments

Create a new deployment, currently the only supported type is `online`.

If this is a deployment for a prompt template then the `prompt_template` object should exist and the `id` must be the `id` of the prompt template to be deployed.

Auditing

Calling this method generates the following auditing event.

  • pm-20.deployment.create

Request

Request Body

DeploymentResourcePrototype

The deployment request entity.

The following important fields are described for each use case:

  1. Prompt template:
    • `base_model_id`: required
    • `prompt_template.id`: required
    • `online`: required
    • `hardware_spec`: forbidden
    • `hardware_request`: forbidden
    • response `deployed_asset_type`: `foundation_model`
  2. Custom foundation model:
    • `asset.id`: required
    • `online`: required
    • `online.parameters.foundation_model`: optional
    • `hardware_spec`: required
    • `hardware_request`: forbidden
    • `base_model_id`: forbidden
    • `base_deployment_id`: forbidden
    • response `deployed_asset_type`: `custom_foundation_model`
  3. Deploy on Demand model:
    • `asset.id`: required
    • `online`: required
    • `online.parameters.foundation_model`: forbidden
    • `hardware_spec`: optional
    • `hardware_request`: forbidden
    • `base_model_id`: forbidden
    • `base_deployment_id`: forbidden
    • `space_id`: required
    • `project_id`: forbidden
    • response `deployed_asset_type`: `curated_foundation_model`

name

Required *

string

The name of the resource.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

description

string

A description of the resource.

tags

Tags

A list of tags for this resource.

custom

Custom

User defined properties specified as key-value pairs.

prompt_template

SimpleRel

A reference to a resource.

id

Required *

string

The id of the referenced resource.

online

Required *

OnlineDeployment

Indicates that this is an online deployment. An object has to be specified but can be empty. The `serving_name` can be provided in the `online.parameters`.

parameters

object

A set of key-value pairs that are used to configure the deployment.

hardware_spec

HardwareSpec

A hardware specification.

id

string

The id of the hardware specification.

rev

string

The revision of the hardware specification.

name

string

The name of the hardware specification.

num_nodes

integer

The number of nodes applied to a computation.

hardware_request

HardwareRequest

The requested hardware for deployment.

size

string

The size of GPU requested for the deployment.

num_nodes

number

The number of nodes for the GPU requested for deployment.

asset

Rel

A reference to a resource.

id

Required *

string

The id of the referenced resource.

rev

string

The revision of the referenced resource.

base_model_id

string

The base model that is required for this deployment if this is for a prompt template for an IBM foundation model.

Response

202 - Deployment created.

metadata

ResourceMeta

Common metadata for a simple resource.

entity

DeploymentEntity

The common fields between a request and the response.

400 -

401 -

403 -

404 -

Retrieve the deployments

GET /ml/v4/deployments

Retrieve the list of deployments for the specified space or project.

Auditing

Calling this method generates the following auditing event.

  • pm-20.deployment.list

Request

Path Parameters

Query Parameters

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

serving_name

string

Retrieves the deployment, if any, that contains this `serving_name`.

tag.value

string

Retrieves only the resources with the given tag value.

asset_id

string

Retrieves only the resources with the given asset_id, asset_id would be the model id.

prompt_template_id

string

Retrieves only the resources with the given prompt_template_id.

name

string

Retrieves only the resources with the given name.

type

string

Retrieves the resources filtered with the given type. There are the deployment types as well as an additional `prompt_template` if the deployment type includes a prompt template.

The supported deployment types are (see the description for `deployed_asset_type` in the deployment entity):

  1. `foundation_model` - when a prompt template is used on a pre-deployed IBM provided model.

  2. `custom_foundation_model` - when a custom foundation model is deployed.

  3. `curated_foundation_model` - when a deploy on demand model is deployed. These can be combined with the flag `prompt_template` like this:

  4. `type=foundation_model` - return all prompt template deployments.

  5. `type=foundation_model and prompt_template` - return all prompt template deployments - this is the same as the previous query because a `foundation_model` can only exist with a prompt template.

  6. `type=prompt_template` - return all deployments with a prompt template.

state

string

Retrieves the resources filtered by state. Allowed values are `initializing`, `updating`, `ready` and `failed`.

conflict

boolean

Returns whether `serving_name` is available for use or not. This query parameter cannot be combined with any other parameter except for `serving_name`.

Response

200 - OK.

total_count

integer

The total number of resources. Computed explicitly only when `total_count=true` query parameter is present. This is in order to avoid performance penalties.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

array

A list of deployment resources.

system

DeploymentSystem

System details including warnings.

204 - `serving_name` is available for use.

Returned when `serving_name` and `conflict` query parameters are used.

400 -

401 -

403 -

404 -

409 - Returned when `serving_name` and `conflict` query parameters are used.

The response body will contain the reason.

trace

string

An identifier that can be used to trace the request.

status_code

integer

The corresponding error code in integer.

errors

array

The list of errors.

Retrieve the deployment details

GET /ml/v4/deployments/{deployment_id}

Retrieve the deployment details with the specified identifier.

Auditing

Calling this method generates the following auditing event.

  • pm-20.deployment.read

Request

Path Parameters

Query Parameters

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

attempt_activation

boolean

Attempts activation for the deployment with specified `deployment_id`, if it is hibernated and if it is set to true.

Response

200 - Deployment details.

metadata

ResourceMeta

Common metadata for a simple resource.

entity

DeploymentEntity

The common fields between a request and the response.

400 -

401 -

403 -

404 -

Update the deployment metadata

PATCH /ml/v4/deployments/{deployment_id}

Update the deployment metadata. The following parameters of deployment metadata are supported for the patch operation.

  • `/name`
  • `/description`
  • `/tags`
  • `/custom`
  • `/online/parameters`
  • `/asset` - `replace` only
  • `/prompt_template` - `replace` only
  • `/hardware_spec`
  • `/hardware_request`
  • `/base_model_id` - `replace` only (applicable only to prompt template deployments referring to IBM base foundation models)

The PATCH operation with path specified as `/online/parameters` can be used to update the `serving_name`.

Auditing

Calling this method generates the following auditing event.

  • pm-20.deployment.update

Request

Request Body

The json patch.

Path Parameters

Query Parameters

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

Response

202 - Deployment accepted

metadata

ResourceMeta

Common metadata for a simple resource.

entity

DeploymentEntity

The common fields between a request and the response.

400 -

401 -

403 -

404 -

Delete the deployment

DELETE /ml/v4/deployments/{deployment_id}

Delete the deployment with the specified identifier.

Auditing

Calling this method generates the following auditing event.

  • pm-20.deployment.delete

Request

Path Parameters

Query Parameters

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

Response

204 - Deployment deleted.

400 -

401 -

404 -

Deployment Text Chat.

Return options

Note that there is currently a limitation in this operation when using `return_options`, for input only `input_text` will be returned if requested, for output the `input_tokens` and `generated_tokens` will not be returned. ">

Infer text

POST /ml/v1/deployments/{id_or_name}/text/generation

Infer the next tokens for a given deployed model with a set of parameters. If a `serving_name` is used then it must match the `serving_name` that is returned in the `inference` section when the deployment was created.

This API is legacy, consider using Deployment Text Chat.

Return options

Note that there is currently a limitation in this operation when using `return_options`, for input only `input_text` will be returned if requested, for output the `input_tokens` and `generated_tokens` will not be returned.

Auditing

Calling this method generates the following auditing event.

  • pm-20.foundation-model.send

Request

Request Body

DeploymentTextGenRequest

From a given prompt, infer the next tokens.

input

string

The prompt to generate completions. Note: The method tokenizes the input internally. It is recommended not to leave any trailing spaces.

This field is ignored if there is a prompt template.

parameters

DeploymentTextGenProperties

Properties that control the model and response.

decoding_method

string

Represents the strategy used for picking the tokens during generation of the output text.

During text generation when parameter value is set to greedy, each successive token corresponds to the highest probability token given the text that has already been generated. This strategy can lead to repetitive results especially for longer output sequences. The alternative sample strategy generates text by picking subsequent tokens based on the probability distribution of possible next tokens defined by (i.e., conditioned on) the already-generated text and the top_k and top_p parameters described below. See this url for an informative article about text generation.

In future implementations, this parameter will be automatically set depending on the `temperature` parameter so this parameter will be ignored.

length_penalty

object

It can be used to exponentially increase the likelihood of the text generation terminating once a specified number of tokens have been generated.

In future implementations, this parameter will be ignored.

max_new_tokens

integer

The maximum number of new tokens to be generated. The maximum supported value for this field depends on the model being used.

How the "token" is defined depends on the tokenizer and vocabulary size, which in turn depends on the model. Often the tokens are a mix of full words and sub-words. To learn more about tokenization, see here.

Depending on the users plan, and on the model being used, there may be an enforced maximum number of new tokens.

min_new_tokens

integer

If stop sequences are given, they are ignored until minimum tokens are generated.

random_seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop_sequences

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

temperature

number

A value used to modify the next-token probabilities in sampling mode. Values less than 1.0 sharpen the probability distribution, resulting in "less random" output. Values greater than 1.0 flatten the probability distribution, resulting in "more random" output. A value of 1.0 has no effect.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the TIME_LIMIT stop reason.

Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

top_k

integer

The number of highest probability vocabulary tokens to keep for top-k-filtering. Only applies for sampling mode. When decoding_strategy is set to sample, only the top_k most likely tokens are considered as candidates for the next generated token.

top_p

number

Similar to top_k except the candidates to generate the next token are the most likely tokens with probabilities that add up to at least top_p. Also known as nucleus sampling. A value of 1.0 is equivalent to disabled.

repetition_penalty

number

Represents the penalty for penalizing tokens that have already been generated or belong to the context. The value 1.0 means that there is no penalty.

truncate_input_tokens

integer

Represents the maximum number of input tokens accepted. This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the start of the input (on the left), so the end of the input will remain the same. If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

Properties that control what is returned.

include_stop_sequence

boolean

Pass `false` to omit matched stop sequences from the end of the output text. The default is `true`, meaning that the output will end with the stop sequence text when matched.

typical_p

number

Local typicality measures how similar the conditional probability of predicting a target token next is to the expected conditional probability of predicting a random token next, given the partial text already generated. If less than 1, the smallest set of the most locally typical tokens with probabilities that add up to typical_p or higher are kept for generation.

prompt_variables

object

The prompt variables.

moderations

Moderations

Properties that control the moderations, for usages such as `Hate and profanity` (HAP) and `Personal identifiable information` (PII) filtering. This list can be extended with new types of moderations.

hap

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

pii

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

granite_guardian

object

The properties specific to Granite Guardian. This detector is in beta and may change.

input_ranges

array

If set, then only these ranges will be applied to the moderations. This is useful in the case that certain parts of the input text have already been checked.

Response

200 - Successful operation

model_id

string

The `id` of the model for inference.

model_version

string

The model version (using semantic versioning) if set.

created_at

string

The time when the response was created in ISO 8601 format.

results

array

The generated tokens.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Deployment Text Chat Stream.

Return options

Note that there is currently a limitation in this operation when using `return_options`, for input only `input_text` will be returned if requested, for output the `input_tokens` and `generated_tokens` will not be returned, also the `rank` and `top_tokens` will not be returned. ">

Infer text event stream

POST /ml/v1/deployments/{id_or_name}/text/generation_stream

Infer the next tokens for a given deployed model with a set of parameters. This operation will return the output tokens as a stream of events. If a `serving_name` is used then it must match the `serving_name` that is returned in the `inference` section when the deployment was created.

This API is legacy, consider using Deployment Text Chat Stream.

Return options

Note that there is currently a limitation in this operation when using `return_options`, for input only `input_text` will be returned if requested, for output the `input_tokens` and `generated_tokens` will not be returned, also the `rank` and `top_tokens` will not be returned.

Auditing

Calling this method generates the following auditing event.

  • pm-20.foundation-model.send

Request

Request Body

DeploymentTextGenRequest

From a given prompt, infer the next tokens in a server-sent events (SSE) stream.

input

string

The prompt to generate completions. Note: The method tokenizes the input internally. It is recommended not to leave any trailing spaces.

This field is ignored if there is a prompt template.

parameters

DeploymentTextGenProperties

Properties that control the model and response.

decoding_method

string

Represents the strategy used for picking the tokens during generation of the output text.

During text generation when parameter value is set to greedy, each successive token corresponds to the highest probability token given the text that has already been generated. This strategy can lead to repetitive results especially for longer output sequences. The alternative sample strategy generates text by picking subsequent tokens based on the probability distribution of possible next tokens defined by (i.e., conditioned on) the already-generated text and the top_k and top_p parameters described below. See this url for an informative article about text generation.

In future implementations, this parameter will be automatically set depending on the `temperature` parameter so this parameter will be ignored.

length_penalty

object

It can be used to exponentially increase the likelihood of the text generation terminating once a specified number of tokens have been generated.

In future implementations, this parameter will be ignored.

max_new_tokens

integer

The maximum number of new tokens to be generated. The maximum supported value for this field depends on the model being used.

How the "token" is defined depends on the tokenizer and vocabulary size, which in turn depends on the model. Often the tokens are a mix of full words and sub-words. To learn more about tokenization, see here.

Depending on the users plan, and on the model being used, there may be an enforced maximum number of new tokens.

min_new_tokens

integer

If stop sequences are given, they are ignored until minimum tokens are generated.

random_seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop_sequences

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

temperature

number

A value used to modify the next-token probabilities in sampling mode. Values less than 1.0 sharpen the probability distribution, resulting in "less random" output. Values greater than 1.0 flatten the probability distribution, resulting in "more random" output. A value of 1.0 has no effect.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the TIME_LIMIT stop reason.

Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

top_k

integer

The number of highest probability vocabulary tokens to keep for top-k-filtering. Only applies for sampling mode. When decoding_strategy is set to sample, only the top_k most likely tokens are considered as candidates for the next generated token.

top_p

number

Similar to top_k except the candidates to generate the next token are the most likely tokens with probabilities that add up to at least top_p. Also known as nucleus sampling. A value of 1.0 is equivalent to disabled.

repetition_penalty

number

Represents the penalty for penalizing tokens that have already been generated or belong to the context. The value 1.0 means that there is no penalty.

truncate_input_tokens

integer

Represents the maximum number of input tokens accepted. This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the start of the input (on the left), so the end of the input will remain the same. If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

Properties that control what is returned.

include_stop_sequence

boolean

Pass `false` to omit matched stop sequences from the end of the output text. The default is `true`, meaning that the output will end with the stop sequence text when matched.

typical_p

number

Local typicality measures how similar the conditional probability of predicting a target token next is to the expected conditional probability of predicting a random token next, given the partial text already generated. If less than 1, the smallest set of the most locally typical tokens with probabilities that add up to typical_p or higher are kept for generation.

prompt_variables

object

The prompt variables.

moderations

Moderations

Properties that control the moderations, for usages such as `Hate and profanity` (HAP) and `Personal identifiable information` (PII) filtering. This list can be extended with new types of moderations.

hap

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

pii

object

The properties for the moderation. Each type of moderation may have additional properties that are specific to that moderation.

granite_guardian

object

The properties specific to Granite Guardian. This detector is in beta and may change.

input_ranges

array

If set, then only these ranges will be applied to the moderations. This is useful in the case that certain parts of the input text have already been checked.

Response

200 - Successful operation (`Content-Type: text/event-stream`).

400 -

401 -

403 -

404 -

Deployment - Prompt template - Text chat

If `stream` is true, this operation will return the output tokens in a server-sent events (SSE) stream. ">

Infer chat completions

POST /ml/v1/deployments/{id_or_name}/chat/completions

Infers the next chat message for a given deployment. The deployment must reference either a prompt template with `input_mode` set to `chat`, a custom foundation model, or a curated foundation model. When a prompt template is referenced, the model used for the chat request is specified by the deployment's `base_model_id`. Chat parameters are derived from the prompt template's `model_parameters`. If a `serving_name` is provided, it must match the `serving_name` returned in the inference section at the time of deployment creation.

Related guides: - Deployment - Prompt template - Text chat

If `stream` is true, this operation will return the output tokens in a server-sent events (SSE) stream.

Auditing

Calling this method generates the following auditing event.

  • chat-completions.send

Request

Request Body

DeploymentTextChatRequest

From a given prompt, infer the next chat message.

messages

Required *

array

The messages for this chat session.

If the deployment references a prompt template then `system` `role` can not be in `messages`. For such deployments, depending on the model, the `content` of `system` `role` may be from `system_prompt` of the prompt template, and will be automatically inserted into `messages`. As an example, depending on the model, if `system_prompt` of a prompt template is "You are Granite Chat, an AI language model developed by IBM. You are a cautious assistant. You carefully follow instructions. You are helpful and harmless and you follow ethical guidelines and promote positive behavior.", a message with `system` `role` having `content` the same as `system_prompt` is inserted.

tools

array

Tool functions that can be called with the response.

tool_choice_option

string

Specify either `tool_choice_option` to allow the model to pick or `tool_choice` to force the model to call a tool.

Using `auto` means the model can pick between generating a message or calling one or more tools. Default is `auto`.

Using `none` means the model will not call any tool and instead generates a message.

Using `required` means the model must call one or more tools.

tool_choice

TextChatToolChoiceTool

Specifying a particular tool via `{"type": "function", "function": {"name": "my_function"}}` forces the model to call that tool. Specify either `tool_choice_option` to allow the model to pick or `tool_choice` to force the model to call a tool.

type

Required *

string

The tool type.

function

Required *

object

The named function.

context

string

If specified, `context` will be inserted into `messages`. Depending on the model, `context` may be inserted into the `content` with `system` `role`; or into the `content` of the last message of `user` `role`.

In the example, `context` "Today is Wednesday" is inserted as such `content` of `user` becomes "Today is Wednesday. Who are you and which day is tomorrow?"

chat_template_kwargs

object

Additional kwargs to pass to the chat template, described as a JSON Schema object. See the JSON Schema reference for documentation about the format.

frequency_penalty

number

Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.

include_reasoning

boolean

Whether to include `reasoning_content` in the response. Default is `true`.

logit_bias

object

Increasing or decreasing probability of tokens being selected during generation; a positive bias makes a token more likely to appear, while a negative bias makes it less likely.

logprobs

boolean

Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message.

top_logprobs

integer

An integer specifying the number of most likely tokens to return at each token position, each with an associated log probability. The option `logprobs` must be set to `true` if this parameter is used.

max_completion_tokens

integer

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length. Set to 0 for the model's configured max generated tokens.

max_tokens

integer

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length. Set to 0 for the model's configured max generated tokens.

This value is now deprecated in favor of `max_completion_tokens`. If specified together with `max_completion_tokens`, `max_tokens` will be ignored.

n

integer

How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs.

presence_penalty

number

Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.

reasoning_effort

string

A lower reasoning effort can result in faster responses, fewer tokens used, and shorter `reasoning_content` in the responses. Supported values are `low`, `medium`, and `high`.

response_format

TextChatResponseFormat

The chat response format parameters.

type

Required *

string

Used to enable JSON mode, which guarantees the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if `finish_reason="length"`, which indicates the generation exceeded `max_tokens` or the conversation exceeded the max context length.

  • `text` : Will not create a JSON structured output.
  • `json_object` : User will get a JSON structured output, but the schema is not guranteed.
  • `json_schema` : User needs to declare the `json_schema` object to provide the desired JSON schema in order to get a matched response.
json_schema

object

User-defined JSON schema object with optional parameters to enforce structured output.

Important: this field will only applied when `response_format`.`type` is set to `json_schema`.

seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

stream

boolean

If set to true, this operation will return the output tokens as a stream of events, and usage is always included in the response.

temperature

number

What sampling temperature to use,. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.

We generally recommend altering this or `top_p` but not both.

top_p

number

An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

We generally recommend altering this or `temperature` but not both.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the `TIME_LIMIT`` stop reason. Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

Response

200 - Successful operation. `Content-Type: text/event-stream` if `stream` is true.

id

string

A unique identifier for the chat completion.

model_id

string

The model used for the chat completion.

model

string

This field is a duplicate of `model_id` and is provided in order to provide better compatibility with other APIs.

model_version

string

The model version (using semantic versioning) if set.

created

integer

The Unix timestamp (in seconds) of when the chat completion was created.

created_at

string

The time when the response was created in ISO 8601 format.

usage

TextChatUsage

Usage statistics for the completion request.

moderations

ModerationResults

The result of any detected moderations.

choices

array

A list of chat completion choices. Can be more than one if `n` is greater than 1.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Deployment - Prompt template - Text chat

You can also use Deployment Chat Completions to achieve the same result. ">

Infer text chat

POST /ml/v1/deployments/{id_or_name}/text/chat

Infers the next chat message for a given deployment. The deployment must reference either a prompt template with `input_mode` set to `chat`, a custom foundation model, or a curated foundation model. When a prompt template is referenced, the model used for the chat request is specified by the deployment's `base_model_id`. Chat parameters are derived from the prompt template's `model_parameters`. If a `serving_name` is provided, it must match the `serving_name` returned in the inference section at the time of deployment creation.

Related guides: - Deployment - Prompt template - Text chat

You can also use Deployment Chat Completions to achieve the same result.

Auditing

Calling this method generates the following auditing event.

  • pm-20.foundation-model.send

Request

Request Body

DeploymentTextChatRequest

From a given prompt, infer the next chat message.

messages

Required *

array

The messages for this chat session.

If the deployment references a prompt template then `system` `role` can not be in `messages`. For such deployments, depending on the model, the `content` of `system` `role` may be from `system_prompt` of the prompt template, and will be automatically inserted into `messages`. As an example, depending on the model, if `system_prompt` of a prompt template is "You are Granite Chat, an AI language model developed by IBM. You are a cautious assistant. You carefully follow instructions. You are helpful and harmless and you follow ethical guidelines and promote positive behavior.", a message with `system` `role` having `content` the same as `system_prompt` is inserted.

tools

array

Tool functions that can be called with the response.

tool_choice_option

string

Specify either `tool_choice_option` to allow the model to pick or `tool_choice` to force the model to call a tool.

Using `auto` means the model can pick between generating a message or calling one or more tools. Default is `auto`.

Using `none` means the model will not call any tool and instead generates a message.

Using `required` means the model must call one or more tools.

tool_choice

TextChatToolChoiceTool

Specifying a particular tool via `{"type": "function", "function": {"name": "my_function"}}` forces the model to call that tool. Specify either `tool_choice_option` to allow the model to pick or `tool_choice` to force the model to call a tool.

type

Required *

string

The tool type.

function

Required *

object

The named function.

context

string

If specified, `context` will be inserted into `messages`. Depending on the model, `context` may be inserted into the `content` with `system` `role`; or into the `content` of the last message of `user` `role`.

In the example, `context` "Today is Wednesday" is inserted as such `content` of `user` becomes "Today is Wednesday. Who are you and which day is tomorrow?"

chat_template_kwargs

object

Additional kwargs to pass to the chat template, described as a JSON Schema object. See the JSON Schema reference for documentation about the format.

frequency_penalty

number

Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.

include_reasoning

boolean

Whether to include `reasoning_content` in the response. Default is `true`.

logit_bias

object

Increasing or decreasing probability of tokens being selected during generation; a positive bias makes a token more likely to appear, while a negative bias makes it less likely.

logprobs

boolean

Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message.

top_logprobs

integer

An integer specifying the number of most likely tokens to return at each token position, each with an associated log probability. The option `logprobs` must be set to `true` if this parameter is used.

max_completion_tokens

integer

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length. Set to 0 for the model's configured max generated tokens.

max_tokens

integer

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length. Set to 0 for the model's configured max generated tokens.

This value is now deprecated in favor of `max_completion_tokens`. If specified together with `max_completion_tokens`, `max_tokens` will be ignored.

n

integer

How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs.

presence_penalty

number

Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.

reasoning_effort

string

A lower reasoning effort can result in faster responses, fewer tokens used, and shorter `reasoning_content` in the responses. Supported values are `low`, `medium`, and `high`.

response_format

TextChatResponseFormat

The chat response format parameters.

type

Required *

string

Used to enable JSON mode, which guarantees the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if `finish_reason="length"`, which indicates the generation exceeded `max_tokens` or the conversation exceeded the max context length.

  • `text` : Will not create a JSON structured output.
  • `json_object` : User will get a JSON structured output, but the schema is not guranteed.
  • `json_schema` : User needs to declare the `json_schema` object to provide the desired JSON schema in order to get a matched response.
json_schema

object

User-defined JSON schema object with optional parameters to enforce structured output.

Important: this field will only applied when `response_format`.`type` is set to `json_schema`.

seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

stream

boolean

If set to true, this operation will return the output tokens as a stream of events, and usage is always included in the response.

temperature

number

What sampling temperature to use,. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.

We generally recommend altering this or `top_p` but not both.

top_p

number

An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

We generally recommend altering this or `temperature` but not both.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the `TIME_LIMIT`` stop reason. Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

Response

200 - Successful operation

id

string

A unique identifier for the chat completion.

model_id

string

The model used for the chat completion.

model

string

This field is a duplicate of `model_id` and is provided in order to provide better compatibility with other APIs.

model_version

string

The model version (using semantic versioning) if set.

created

integer

The Unix timestamp (in seconds) of when the chat completion was created.

created_at

string

The time when the response was created in ISO 8601 format.

usage

TextChatUsage

Usage statistics for the completion request.

moderations

ModerationResults

The result of any detected moderations.

choices

array

A list of chat completion choices. Can be more than one if `n` is greater than 1.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Deployment Chat Completions with `stream` option set to true to achieve the same result. ">

Infer text chat event stream

POST /ml/v1/deployments/{id_or_name}/text/chat_stream

Infers the next chat message for a given deployment. This operation will return the output tokens as a stream of events. The deployment must reference either a prompt template with `input_mode` set to `chat`, a custom foundation model, or a curated foundation model. When a prompt template is referenced, the model used for the chat request is specified by the deployment's `base_model_id`. Chat parameters are derived from the prompt template's `model_parameters`. If a `serving_name` is provided, it must match the `serving_name` returned in the inference section at the time of deployment creation. Related guides: - Deployment - Prompt template - Text chat

You can also use Deployment Chat Completions with `stream` option set to true to achieve the same result.

Auditing

Calling this method generates the following auditing event.

  • pm-20.foundation-model.send

Request

Request Body

DeploymentTextChatRequest

From a given prompt, infer the next chat message in a server-sent events (SSE) stream.

messages

Required *

array

The messages for this chat session.

If the deployment references a prompt template then `system` `role` can not be in `messages`. For such deployments, depending on the model, the `content` of `system` `role` may be from `system_prompt` of the prompt template, and will be automatically inserted into `messages`. As an example, depending on the model, if `system_prompt` of a prompt template is "You are Granite Chat, an AI language model developed by IBM. You are a cautious assistant. You carefully follow instructions. You are helpful and harmless and you follow ethical guidelines and promote positive behavior.", a message with `system` `role` having `content` the same as `system_prompt` is inserted.

tools

array

Tool functions that can be called with the response.

tool_choice_option

string

Specify either `tool_choice_option` to allow the model to pick or `tool_choice` to force the model to call a tool.

Using `auto` means the model can pick between generating a message or calling one or more tools. Default is `auto`.

Using `none` means the model will not call any tool and instead generates a message.

Using `required` means the model must call one or more tools.

tool_choice

TextChatToolChoiceTool

Specifying a particular tool via `{"type": "function", "function": {"name": "my_function"}}` forces the model to call that tool. Specify either `tool_choice_option` to allow the model to pick or `tool_choice` to force the model to call a tool.

type

Required *

string

The tool type.

function

Required *

object

The named function.

context

string

If specified, `context` will be inserted into `messages`. Depending on the model, `context` may be inserted into the `content` with `system` `role`; or into the `content` of the last message of `user` `role`.

In the example, `context` "Today is Wednesday" is inserted as such `content` of `user` becomes "Today is Wednesday. Who are you and which day is tomorrow?"

chat_template_kwargs

object

Additional kwargs to pass to the chat template, described as a JSON Schema object. See the JSON Schema reference for documentation about the format.

frequency_penalty

number

Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.

include_reasoning

boolean

Whether to include `reasoning_content` in the response. Default is `true`.

logit_bias

object

Increasing or decreasing probability of tokens being selected during generation; a positive bias makes a token more likely to appear, while a negative bias makes it less likely.

logprobs

boolean

Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message.

top_logprobs

integer

An integer specifying the number of most likely tokens to return at each token position, each with an associated log probability. The option `logprobs` must be set to `true` if this parameter is used.

max_completion_tokens

integer

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length. Set to 0 for the model's configured max generated tokens.

max_tokens

integer

The maximum number of tokens that can be generated in the chat completion. The total length of input tokens and generated tokens is limited by the model's context length. Set to 0 for the model's configured max generated tokens.

This value is now deprecated in favor of `max_completion_tokens`. If specified together with `max_completion_tokens`, `max_tokens` will be ignored.

n

integer

How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs.

presence_penalty

number

Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.

reasoning_effort

string

A lower reasoning effort can result in faster responses, fewer tokens used, and shorter `reasoning_content` in the responses. Supported values are `low`, `medium`, and `high`.

response_format

TextChatResponseFormat

The chat response format parameters.

type

Required *

string

Used to enable JSON mode, which guarantees the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if `finish_reason="length"`, which indicates the generation exceeded `max_tokens` or the conversation exceeded the max context length.

  • `text` : Will not create a JSON structured output.
  • `json_object` : User will get a JSON structured output, but the schema is not guranteed.
  • `json_schema` : User needs to declare the `json_schema` object to provide the desired JSON schema in order to get a matched response.
json_schema

object

User-defined JSON schema object with optional parameters to enforce structured output.

Important: this field will only applied when `response_format`.`type` is set to `json_schema`.

seed

integer

Random number generator seed to use in sampling mode for experimental repeatability.

stop

array

Stop sequences are one or more strings which will cause the text generation to stop if/when they are produced as part of the output. Stop sequences encountered prior to the minimum number of tokens being generated will be ignored.

stream

boolean

If set to true, this operation will return the output tokens as a stream of events, and usage is always included in the response.

temperature

number

What sampling temperature to use,. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.

We generally recommend altering this or `top_p` but not both.

top_p

number

An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

We generally recommend altering this or `temperature` but not both.

time_limit

integer

Time limit in milliseconds - if not completed within this time, generation will stop. The text generated so far will be returned along with the `TIME_LIMIT`` stop reason. Depending on the users plan, and on the model being used, there may be an enforced maximum time limit.

Response

200 - Successful operation (`Content-Type: text/event-stream`).

400 -

401 -

403 -

404 -

Time series forecast

POST /ml/v1/deployments/{id_or_name}/time_series/forecast

Generate forecasts, or predictions for future time points, given historical time series data.

Auditing

Calling this method generates the following auditing event.

  • pm-20.time-series-forecast.send

Request

Request Body

DeploymentTSForecastResource

The forecast request.

data

Required *

object

A payload of data matching `schema`. We assume the following about your data: * All timeseries are of equal length and are uniform in nature (the time difference between two successive rows is constant). This implies that there are no missing rows of data; * The data meet the minimum model-dependent historical context length which can be any number of rows per timeseries;

Note that the example payloads shown are for illustration purposes only. An actual payload would necessary be much larger to meet minimum model-specific context lengths.

parameters

DeploymentTSForecastParameters

The parameters for the forecast request.

prediction_length

integer

The prediction length for the forecast. The service will return this many periods beyond the last timestamp in the inference data payload. If specified, `prediction_length` must be an integer >=1 and no more than the model default prediction length. When omitted the model default prediction_length will be used.

inference_batch_size

integer

The batch size used during inference. When multiple time series are present, the inference will be conducted in batches. If not specified, the model default batch size will be used.

schema

Required *

TSForecastInputSchema

Contains metadata about your timeseries data input.

timestamp_column

Required *

string

A valid column in the data that should be treated as the timestamp. Although not absolutely necessary, if using calendar dates (simple integer time offsets are also allowed), users should consider using a format such as ISO 8601 that includes a UTC offset (e.g., '2024-10-18T01:09:21.454746+00:00'). This will avoid potential issues such as duplicate dates appearing due to daylight savings change overs. There are many date formats in existence and inferring the correct one can be a challenge so please do consider adhering to ISO 8601.

id_columns

array

Columns that define a unique key for timeseries. This is similar to a compound primary key in a database table.

freq

string

A frequency indicator for the given timestamp_column. See https://pandas.pydata.org/pandas-docs/stable/user_guide/timeseries.html#period-aliases for a description of the allowed values. If not provided, we will attempt to infer it from the data.

target_columns

array

An array of column headings which constitute the target variables in the data. These are the data that will be forecasted.

future_data

object

Exogenous or supporting features that extend into the forecasting horizon (e.g., a weather forecast or calendar of special promotions) which are known in advance. `future_data` would be in the same format as `data` except that all timestamps would be in the forecast horizon and it would not include previously specified `target_columns`.

Response

200 - Successful operation

model_id

string

The model used to generate the forecast.

created_at

string

The time when the response was created in ISO 8601 format.

results

array

The list of prediction results. There will be a forecast for each time series in the input data. The `prediction_length` field in the request specifies the number of predictions in the results. The actual number of rows in the results will be equal to the `prediction length` multiplied by the number of unique ids in `id_columns`. The `timestamp_column` field in the request indicates the name of the timestamp column in the results.

input_data_points

integer

The number of input data points (number of rows in `data` * number of input columns in `data`).

output_data_points

integer

The number of forecasted data points (`prediction_length` * number of `target_columns` * number of unique ids in `id_columns`).

400 -

401 -

403 -

404 -

Execute AI service

POST /ml/v4/deployments/{id_or_name}/ai_service

Execute an inference call for the AI service deployment. If a `serving_name` is used then it must match the `serving_name` that is returned in the `inference` section when the deployment was created.

Auditing

Calling this method generates the following auditing event.

  • pm-20.ai_service.send

Request

Request Body

DeploymentAIServiceRequest

Call the deployed AI service with the json payload.

Response

200 - Successful operation

400 -

401 -

403 -

404 -

Execute AI service stream

POST /ml/v4/deployments/{id_or_name}/ai_service_stream

Execute an inference call for the AI service deployment. If a `serving_name` is used then it must match the `serving_name` that is returned in the `inference` section when the deployment was created.

Auditing

Calling this method generates the following auditing event.

  • pm-20.ai_service.send

Request

Request Body

DeploymentAIServiceRequest

Call the deployed AI service with the json payload.

Response

200 - Successful operation

400 -

401 -

403 -

404 -

Create a new watsonx.ai training

POST /ml/v4/trainings

Create a new watsonx.ai training in a project or a space.

In order to deploy the tuned model you need to follow the following steps:

1. Create a WML model asset, in a space or a project,
 by providing the &#x60;request.json&#x60; as shown below:
   &#x60;&#x60;&#x60;
   curl -X POST &quot;https://{cpd_cluster}/ml/v4/models?version&#x3D;2024-01-29&quot; \
     -H &quot;Authorization: Bearer &lt;replace with your token&gt;&quot; \
     -H &quot;content-type: application/json&quot; \
     --data &#x27;{
        &quot;name&quot;: &quot;replace_with_a_meaningful_name&quot;,
        &quot;space_id&quot;: &quot;replace_with_your_space_id&quot;,
        &quot;type&quot;: &quot;prompt_tune_1.0&quot;,
        &quot;software_spec&quot;: {
          &quot;name&quot;: &quot;watsonx-textgen-fm-1.0&quot;
        },
        &quot;metrics&quot;: [ from the training job ],
        &quot;training&quot;: {
          &quot;id&quot;: &quot;05859469-b25b-420e-aefe-4a5cb6b595eb&quot;,
          &quot;base_model&quot;: {
            &quot;model_id&quot;: &quot;google/flan-t5-xl&quot;
          },
          &quot;task_id&quot;: &quot;generation&quot;,
          &quot;verbalizer&quot;: &quot;Input:  Output:&quot;
        },
        &quot;training_data_references&quot;: [
          {
            &quot;connection&quot;: {
              &quot;id&quot;: &quot;20933468-7e8a-4706-bc90-f0a09332b263&quot;
            },
            &quot;id&quot;: &quot;file_to_tune1.json&quot;,
            &quot;location&quot;: {
              &quot;bucket&quot;: &quot;wxproject-donotdelete-pr-xeyivy0rx3vrbl&quot;,
              &quot;path&quot;: &quot;file_to_tune1.json&quot;
            },
            &quot;type&quot;: &quot;connection_asset&quot;
          }
        ]
      }&#x27;
   &#x60;&#x60;&#x60;


   **Notes:**

   1. If you used the training request field &#x60;auto_update_model: true&#x60;
   then you can skip this step as the model will have been saved at
   the end of the training job.
   1. Rather than creating the payload for the model you can use the
      generated &#x60;request.json&#x60; that was stored in the &#x60;results_reference&#x60;
      field, look for the path in the field
      &#x60;entity.results_reference.location.model_request_path&#x60;.
   1. The model &#x60;type&#x60; must be &#x60;prompt_tune_1.0&#x60;.
   1. The software spec name must be &#x60;watsonx-textgen-fm-1.0&#x60;.

1. Create a tuned model deployment as described in the
 [create deployment documentation](#create-deployment).

Auditing

Calling this method generates the following auditing event.

  • pm-20.training.create

Request

Request Body

TrainingResourcePrototype

name

Required *

string

The name of the training.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

description

string

A description of the training.

tags

Tags

A list of tags for this resource.

training_data_references

array

Training datasets.

custom

Custom

User defined properties specified as key-value pairs.

auto_update_model

boolean

If set to `true` then the result of the training, if successful, will be uploaded to the repository as a model.

results_reference

Required *

object

The training results. Normally this is specified as `type=container` (Service) or `type=fs` (Software) which means that it is stored in the space or project.

id

string

Item identification inside a collection.

type

Required *

string

The data source type like `connection_asset`, `container` (Service) or `fs` (Software).

connection

object

Contains a set of fields specific to each connection. See here for details about specifying connections.

location

Required *

object

Contains a set of fields that describe the location of the data with respect to the `connection`.

Response

201 - The training job has been created.

metadata

ResourceMeta

Common metadata for a simple resource.

entity

TrainingResourceEntity

Status of the training job.

400 -

401 -

403 -

404 -

Retrieve the list of trainings

GET /ml/v4/trainings

Retrieve the list of trainings for the specified space or project.

Auditing

Calling this method generates the following auditing event.

  • pm-20.training.list

Request

Path Parameters

Query Parameters

start

string

Token required for token-based pagination. This token cannot be determined by end user. It is generated by the service and it is set in the href available in the `next` field.

limit

integer

How many resources should be returned. By default limit is 100. Max limit allowed is 200.

total_count

boolean

Compute the total count. May have performance impact.

tag.value

string

Return only the resources with the given tag value.

state

string

Filter based on on the training job state.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

Response

200 - OK.

total_count

integer

The total number of resources. Computed explicitly only when `total_count=true` query parameter is present. This is in order to avoid performance penalties.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

array

The training resources.

system

object

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Retrieve the training

GET /ml/v4/trainings/{training_id}

Retrieve the training with the specified identifier.

Auditing

Calling this method generates the following auditing event.

  • pm-20.training.get

Request

Response

200 - OK.

metadata

ResourceMeta

Common metadata for a simple resource.

entity

TrainingResourceEntity

Status of the training job.

400 -

401 -

403 -

404 -

Cancel or delete the training

DELETE /ml/v4/trainings/{training_id}

Cancel or delete the specified training, once deleted all trace of the job is gone.

Auditing

Calling this method generates the following auditing event.

  • pm-20.training.delete

Request

Path Parameters

Query Parameters

hard_delete

boolean

Set to true in order to also delete the job or request metadata.

Response

204 - Training cancelled.

400 -

401 -

403 -

404 -

documentation for a description of text embeddings. ">

Generate embeddings

POST /ml/v1/text/embeddings

Generate embeddings from text input.

See the documentation for a description of text embeddings.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-embeddings.send

Request

Request Body

EmbeddingsRequest

The text input for a given model to be used to generate the embeddings.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

model_id

Required *

string

The `id` of the model to be used for this request. Please refer to the list of models.

inputs

Required *

array

The input text.

parameters

EmbeddingParameters

Parameters for text embedding requests.

truncate_input_tokens

integer

Represents the maximum number of tokens accepted per input.

This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the end of the input (on the right), so the start of the input will remain the same.

If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

The return options for text embeddings.

crypto

CryptoInfo

To enable encryption, configure credentials for your chosen keys management service. For details, see Encrypting inference requests.

key_ref

Required *

string

Identifier of the DEK in the chosen keys management service.

  • IBM Key Protect - full CRN (e.g. `crn:v1:bluemix:public:kms:us-south:a/12345:<instance_id>:key:<root_key_id>:wdek:<ciphertext>`) This field is required, but its exact format depends on the selected `keys_manager`. No strict pattern is enforced here - validation will be performed by the keys management service.

Response

200 - Successful operation

model_id

string

The `id` of the model to be used for this request. Please refer to the list of models.

results

array

The embedding values for a given text.

created_at

string

The time when the response was created in ISO 8601 format.

input_token_count

integer

The number of input tokens that were consumed.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Detect text similarities

POST /ml/v1/text/similarities

Detect similarities between source strings and target strings.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-similarities.send

Request

Request Body

SimilarityRequest

The strings to be used to detect text similarities.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

model_id

Required *

string

The `id` of the model to be used for this request. Please refer to the list of models.

source_text

Required *

string

A source text.

target_texts

Required *

array

The target texts.

parameters

SimilarityParameters

Parameters for text similarity.

truncate_input_tokens

integer

Represents the maximum number of tokens accepted per input.

This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the end of the input (on the right), so the start of the input will remain the same.

If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

The return options for text similarity.

Response

200 - Successful operation

model_id

string

The `id` of the model to be used for this request. Please refer to the list of models.

results

array

The similarity scores.

created_at

string

The time when the response was created in ISO 8601 format.

input_token_count

integer

The number of input tokens that were consumed.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Generate rerank

POST /ml/v1/text/rerank

Rerank texts based on some queries.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-rerank.send

Request

Request Body

RerankRequest

The input texts and the queries for reranking.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

model_id

Required *

string

The `id` of the model to be used for this request. Please refer to the list of models.

inputs

Required *

array

The rank input strings.

query

Required *

string

The rank query.

parameters

RerankParameters

The properties used for reranking.

truncate_input_tokens

integer

Represents the maximum number of tokens accepted per input.

This can be used to avoid requests failing due to input being longer than configured limits. If the text is truncated, then it truncates the end of the input (on the right), so the start of the input will remain the same.

If this value exceeds the `maximum sequence length` (refer to the documentation to find this value for the model) then the call will fail if the total number of tokens exceeds the `maximum sequence length`.

return_options

object

The return options for text reranking.

crypto

CryptoInfo

To enable encryption, configure credentials for your chosen keys management service. For details, see Encrypting inference requests.

key_ref

Required *

string

Identifier of the DEK in the chosen keys management service.

  • IBM Key Protect - full CRN (e.g. `crn:v1:bluemix:public:kms:us-south:a/12345:<instance_id>:key:<root_key_id>:wdek:<ciphertext>`) This field is required, but its exact format depends on the selected `keys_manager`. No strict pattern is enforced here - validation will be performed by the keys management service.

Response

200 - Successful operation

model_id

string

The `id` of the model to be used for this request. Please refer to the list of models.

model_version

string

The model version (using semantic versioning) if set.

results

array

The ranked results.

created_at

string

The time when the response was created in ISO 8601 format.

input_token_count

integer

The number of input tokens that were consumed.

query

string

The rank query, if requested.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Create a geospatial transformation

POST /ml/v1/geospatial/transformations

Create a geospatial transformation from inputs using a given model.

Request

Request Body

GeospatialTransformationRequest

The details of the inputs to transform with the given model.

model_id

Required *

string

The `id` of the model to be used for this request.

inputs

Required *

array

The input text.

output

Required *

GeospatialTransformationData

A data location of the input or output data.

url

string

A signed url for the data in COS or elsewhere. This url will be used to download if this is input, or upload if this is output.

space_id

Required *

string

The space that contains the resource.

Response

201 - Created. The `Content-Location` header will contain the URI reference to the created resource.

metadata

GeospatialTransformationMetadata

Common metadata for a simple resource.

entity

GeospatialTransformationResponseEntity

The inputs and outputs required to create a transformation for the given model.

400 -

401 -

403 -

404 -

Retrieve the geospatial transformation requests

GET /ml/v1/geospatial/transformations

Retrieve the list of geospatial transformation requests for the specified space or project.

This operation does not save the history, any requests that were deleted or purged will not appear in this list.

Request

Path Parameters

Query Parameters

version

Required *

string

The version date for the API of the form `YYYY-MM-DD`.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

start

string

Token required for token-based pagination. This token cannot be determined by end user. It is generated by the service and it is set in the href available in the `next` field.

limit

integer

How many resources should be returned. By default limit is 100. Max limit allowed is 200.

Response

200 - OK.

total_count

integer

The total number of resources. Computed explicitly only when `total_count=true` query parameter is present. This is in order to avoid performance penalties.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

array

A list of resources.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Get a geospatial transformation

GET /ml/v1/geospatial/transformations/{id}

Get a geospatial transformation.

Request

Response

200 - OK.

metadata

GeospatialTransformationMetadata

Common metadata for a simple resource.

entity

GeospatialTransformationResponseEntity

The inputs and outputs required to create a transformation for the given model.

400 -

401 -

403 -

404 -

Delete a geospatial transformation

DELETE /ml/v1/geospatial/transformations/{id}

Delete a geospatial transformation.

Request

Response

204 - Deleted.

400 -

401 -

403 -

404 -

Create a new AutoAI RAG run

POST /ml/v1/autoai/rags

Create a new AutoAI RAG that will find the best RAG pattern from the data that is provided in the request.

Request

Request Body

AutoAIRAGRequest

The details of the AutoAI RAG run with the data used to find the best RAG patterns.

name

Required *

string

The name of the job.

description

string

The description of the job.

tags

Tags

A list of tags for this resource.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

hardware_spec

Required *

HardwareSpec

A hardware specification.

id

string

The id of the hardware specification.

rev

string

The revision of the hardware specification.

name

string

The name of the hardware specification.

num_nodes

integer

The number of nodes applied to a computation.

parameters

AutoAIRAGParameters

The parameters for an AutoAI RAG run.

constraints

object

The constraint parameters for an AutoAI RAG run.

optimization

object

The optimization parameters for an AutoAI RAG run.

deployment

object

Best pattern deployment related properties.

output_logs

boolean

Request that the output logs are also stored as part of the result.

input_data_references

array

A set of input data references.

test_data_references

array

A set of test data references.

knowledge_base_references

array

A set of existing knowledge base references. Applicable to multi-retrieval scenarios. Either `input_data_references` or `knowledge_base_references` must be provided.

vector_store_references

array

A set of vector store references.

custom

Custom

User defined properties specified as key-value pairs.

results_reference

Required *

object

The training results. Normally this is specified as `type=container` (Service) or `type=fs` (Software) which means that it is stored in the space or project.

id

string

Item identification inside a collection.

type

Required *

string

The data source type like `connection_asset`, `container` (Service) or `fs` (Software).

connection

object

Contains a set of fields specific to each connection. See here for details about specifying connections.

location

Required *

object

Contains a set of fields that describe the location of the data with respect to the `connection`.

Response

201 - Created.

metadata

AutoAIRAGMetadata

Common metadata for a simple resource.

entity

AutoAIRAGResponseEntity

The request entity for an AutoAI RAG run.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Retrieve the AutoAI RAG runs

GET /ml/v1/autoai/rags

Retrieve the list of AutoAI RAG requests for the specified space or project.

This operation does not save the history, any requests that were deleted or purged will not appear in this list.

Request

Path Parameters

Query Parameters

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

start

string

Token required for token-based pagination. This token cannot be determined by end user. It is generated by the service and it is set in the href available in the `next` field.

limit

integer

How many resources should be returned. By default limit is 100. Max limit allowed is 200.

Response

200 - OK.

total_count

integer

The total number of resources. Computed explicitly only when `total_count=true` query parameter is present. This is in order to avoid performance penalties.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

array

A list of training definitions.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Get an AutoAI RAG run

GET /ml/v1/autoai/rags/{id}

Get the results of an AutoAI RAG run, or details if the job failed.

Request

Response

200 - OK.

metadata

AutoAIRAGMetadata

Common metadata for a simple resource.

entity

AutoAIRAGResponseEntity

The request entity for an AutoAI RAG run.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Cancel or delete an AutoAI RAG run

DELETE /ml/v1/autoai/rags/{id}

Cancel or delete the specified AutoAI RAG run, once deleted all trace of the run job is gone.

Request

Path Parameters

Query Parameters

hard_delete

boolean

Set to true in order to also delete the job or request metadata.

Response

204 - Deleted.

400 -

401 -

403 -

404 -

documentation for a description of text extraction. ">

Start a text extraction request

POST /ml/v1/text/extractions

Start a request to extract text and metadata from documents.

See the documentation for a description of text extraction.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-extraction.send

Request

Request Body

TextExtractionRequest

The input for the text extraction request.

document_reference

Required *

TextExtractionDataReference

A reference to data.

type

Required *

string

The data source type.

connection

object

Contains a set of location fields specific to each data source.

location

object

Contains a set of fields specific to each connection.

results_reference

Required *

TextExtractionDataReference

A reference to data.

type

Required *

string

The data source type.

connection

object

Contains a set of location fields specific to each data source.

location

object

Contains a set of fields specific to each connection.

parameters

TextExtractionParameters

The parameters for the text extraction.

requested_outputs

array

A list of requested outputs.

mode

string

Which processing mode to use for this request.

ocr_mode

string

If OCR should be used when processing a document. An empty value allows the service to select the best option for your processing mode.

  • `enabled`: OCR is run on embedded images, OCR is only run if no programmatic text could be extracted from the area.
  • `disabled`: OCR is not run, no information is extracted from images or scanned documents.
  • `forced`: Document processing will take a picture of the page and run OCR across it, this applies to all documents even purely programmatic ones.
languages

array

Set of languages to be expected in the document. The language codes follow `ISO 639` where possible. See the documentation for the currently supported languages.

auto_rotation_correction

boolean

Should the service attempt to fix a rotated page or image.

create_embedded_images

string

If the service should return embedded images in the output markdown and JSON formats.

output_dpi

number

The DPI for extracted images.

output_tokens

boolean

Disables returning the individual tokens.

kvp_mode

string

Which version of KVP should be used when processing, if not set then KVP is disabled. See the documentation for more information about the available modes.

semantic_config

object

Properties related to semantic config.

custom

Custom

User defined properties specified as key-value pairs.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

Response

201 - Created. The `Content-Location` header will contain the URI reference to the created resource.

metadata

TextExtractionMetadata

Common metadata for a simple resource.

entity

object

The parameters for the text extraction.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Retrieve the text extraction requests

GET /ml/v1/text/extractions

Retrieve the list of text extraction requests for the specified space or project.

This operation does not save the history, any requests that were deleted or purged will not appear in this list.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-extraction.list

Request

Path Parameters

Query Parameters

version

Required *

string

The version date for the API of the form `YYYY-MM-DD`.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` query parameter has to be given.

start

string

Token required for token-based pagination. This token cannot be determined by end user. It is generated by the service and it is set in the href available in the `next` field.

limit

integer

How many resources should be returned. By default limit is 100. Max limit allowed is 200.

Response

200 - OK.

total_count

integer

The total number of resources. Computed explicitly only when `total_count=true` query parameter is present. This is in order to avoid performance penalties.

limit

integer

The number of items to return in each page.

first

PaginationFirst

The reference to the first item in the current page.

next

PaginationNext

A reference to the first item of the next page, if any.

resources

array

A list of resources.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Get the results of the request

GET /ml/v1/text/extractions/{id}

Retrieve the text extraction request with the specified identifier.

Note that there is a retention period of 2 days. If this retention period is exceeded then the request will be deleted and the results no longer available. In this case this operation will return `404`.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-extraction.get

Request

Response

200 - OK.

metadata

TextExtractionMetadata

Common metadata for a simple resource.

entity

object

The parameters for the text extraction.

system

SystemDetails

Optional details coming from the service and related to the API call or the associated resource.

400 -

401 -

403 -

404 -

Delete the request

DELETE /ml/v1/text/extractions/{id}

Cancel the specified text extraction request and delete any associated results.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-extraction.delete

Request

Path Parameters

Query Parameters

hard_delete

boolean

Set to true in order to also delete the job or request metadata.

Response

204 - Request deleted.

400 -

401 -

403 -

404 -

documentation for a description of image generation. ">

Create an image

POST /ml/v1/text/image

Create an image from a textual description.

See the documentation for a description of image generation.

Auditing

Calling this method generates the following auditing event.

  • pm-20.text-image.send

Request

Request Body

TextImageRequest

The input for the image generation request.

Set the HTTP header `Accept: image/png` in order to get the image in `png` format.

space_id

string

The space that contains the resource. Either `space_id` or `project_id` has to be given.

project_id

string

The project that contains the resource. Either `space_id` or `project_id` has to be given.

model_id

Required *

string

The `id` of the model to be used for this request.

Please refer to the list of models.

input

Required *

string

The textual description of the image to be generated.

parameters

TextImageParameters

Properties that control the image generation.

height

integer

The height of the generated image.

Note that only certain heights may be supported depending on the model being used.

width

integer

The width of the generated image.

Note that only certain widths may be supported depending on the model being used.

moderations

ModerationsInput

Properties that control the moderations, for usages such as `Hate and profanity` (HAP) and `Personal identifiable information` (PII) filtering. This list can be extended with new types of moderations.

hap

object

[...]
